# -----------------------------------------------------------------------------
# $Id: ExternalSocket.pm 779 2005-02-24 14:48:44Z topia $
# -----------------------------------------------------------------------------
# RunLoopǤդΥåȤƻ뤹뤬Ͽΰ٤ˤΥ饹Ѥ롣
# -----------------------------------------------------------------------------
# my $esock = ExternalSocket->new(
#     Socket => IO::Socket::INET->new(...), # IO::SocketΥ֥
#     Read => sub {
#               # åȤɤ߹߲ǽˤʤä˸ƤФ륯㡣
#               # ExternalSocketΥ֥ȼȤĤ˸ƤФ롣
#               my $sock = shift->sock;
#               ...
#             },
#     Write => sub {
#               # åȤ񤭹߲ǽˤʤä˸ƤФ륯㡣
#               my $sock = shift->sock;
#               ...
#             },
#     WantToWrite => sub {
#               # åȤ˽񤭹ɬפ뤫ɤRunLoopΤ٤˸ƤФ륯㡣
#               # ReadWriteƱ֤ͤʤФʤʤ
#               undef;
#             },
#     Exception => sub {
#               # åȤ㳰ȯȤ˸ƤФ륯㡣
#               # άǽ
#               my $this = shift;
#               ::printmsg($this->errmsg('foo socket error'));
#               $this->disconnect;
#             },
#     )->install;
#
# $esock->uninstall;
# -----------------------------------------------------------------------------
package ExternalSocket;
use strict;
use warnings;
use UNIVERSAL;
use Carp;
use Tiarra::Utils;
use Tiarra::Socket;
use base qw(Tiarra::Socket);
utils->define_attr_getter(0, qw(name));

use SelfLoader;
SelfLoader->load_stubs;
1;
__DATA__

sub socket {
    shift->sock(@_);
}

sub new {
    my ($class,%opts) = @_;

    $class->_increment_caller('external-socket', \%opts);
    my $this = $class->SUPER::new(%opts);
    $this->{read} = undef;
    $this->{write} = undef;
    $this->{wanttowrite} = undef;
    $this->{exception} = undef;
    my $this_func = $class . '->new';

    if (defined $opts{Socket}) {
	if (ref $opts{Socket} &&
		UNIVERSAL::isa($opts{Socket},'IO::Socket')) {
	    $this->attach($opts{Socket});
	}
	else {
	    croak "$this_func, Arg{Socket} was illegal object: ".ref($opts{Socket})."\n";
	}
    }
    else {
	croak "$this_func, Arg{Socket} not exists\n";
    }

    foreach my $key (qw/Read Write WantToWrite Exception/) {
	if (defined $opts{$key}) {
	    if (ref($opts{$key}) eq 'CODE') {
		$this->{lc $key} = $opts{$key};
	    }
	    else {
		croak "$this_func, Arg{$key} was illegal reference: ".ref($args{$key})."\n";
	    }
	}
	elsif ($key ne 'Exception') {
	    # Exception is optional
	    croak "$this_func, Arg{$key} not exists\n";
	}
    }

    if (defined $opts{Name}) {
	$this->name($opts{Name});
    }

    $this;
}

sub install {
    # RunLoop˥󥹥ȡ뤹롣
    # άϥǥեȤRunLoop˥󥹥ȡ뤹롣
    my ($this,$runloop) = @_;

    if ($this->installed) {
	croak "This " . ref($this) .
	    " has been already installed to RunLoop\n";
    }

    $runloop = RunLoop->shared unless defined $runloop;
    $this->{runloop} = $runloop;
    $this->SUPER::install;
}

sub uninstall {
    # 󥹥ȡ뤷RunLoop顢ΥåȤ򥢥󥤥󥹥ȡ뤹롣
    my $this = shift;

    if (!$this->installed) {
	# 󥹥ȡ뤵Ƥʤ
	croak "This " . ref($this) . " hasn't been installed yet\n";
    }

    $this->SUPER::uninstall;
}

sub __check_caller {
    my $this = shift;
    my $caller_pkg = utils->get_package(1);
    if (!$caller_pkg->isa('RunLoop')) {
	croak "Only RunLoop may call method read/write/want_to_write of " .
	    ref($this) . "\n";
    }
}

sub read {
    # Read¹Ԥ롣RunLoopΤߤΥ᥽åɤƤ٤롣
    my $this = shift;

    $this->__check_caller;
    $this->{read}->($this);
    $this;
}

sub write {
    # Write¹Ԥ롣
    my $this = shift;

    $this->__check_caller;
    $this->{write}->($this);
    $this;
}

sub want_to_write {
    # WantToWrite¹Ԥ롣
    my $this = shift;

    $this->__check_caller;
    $this->{wanttowrite}->($this);
}

sub exception {
    # Exception¹Ԥ롣
    my $this = shift;

    $this->__check_caller;
    $this->{exception}->($this) if defined $this->{exception};
}

1;
