# -----------------------------------------------------------------------------
# $Id: IrcIO.pm 916 2006-08-12 09:31:41Z topia $
# -----------------------------------------------------------------------------
# IrcIOIRCСϥ饤Ȥ³IRCåꤹݥ饹Ǥ
# -----------------------------------------------------------------------------
package IrcIO;
use strict;
use warnings;
use Carp;
use Configuration;
use Tiarra::IRC::Message;
use Exception;
use Tiarra::ShorthandConfMixin;
use Tiarra::Utils;
use Tiarra::Socket::Buffered;
use base qw(Tiarra::Socket::Buffered);
use base qw(Tiarra::IRC::NewMessageMixin);
utils->define_attr_getter(0, [qw(_runloop runloop)]);
utils->define_proxy('_runloop', 0, qw(irc_message_class));

sub new {
    my ($class, $runloop, %opts) = @_;
    carp 'runloop is not specified!' unless defined $runloop;
    $class->_increment_caller('ircio', \%opts);
    my $this = $class->SUPER::new(runloop => $runloop, %opts);
    $this->{recv_queue} = [];
    $this->{remarks} = {};
    $this;
}

sub server_p {
    shift->isa('IrcIO::Server');
}

sub client_p {
    shift->isa('IrcIO::Client');
}

*remarks = \&remark;
sub remark {
    my ($this,$key,$newvalue) = @_;
    if (!defined $key) {
	croak "IrcIO->remark, Arg[1] is undef.\n";
    }
    elsif (defined $newvalue) {
	$this->{remarks}->{$key} = $newvalue;
    }
    elsif (@_ >= 3) {
	delete $this->{remarks}{$key};
    }
    $this->{remarks}->{$key};
}

sub send_message {
    my ($this,$msg,$encoding) = @_;
    # ǡ褦ͽ󤹤롣åȤνäƤʤƤ֥åʤ

    # msgʸǤɤTiarra::IRC::MessageΥ󥹥󥹤Ǥɤ
    # ʸϤˤϡCRLFդƤϤʤʤ
    # ޤʸˤĤƤʸɤѴԤʤʤ
    my $data_to_send = '';
    if (ref($msg) eq '') {
	# deprecated.
	# FIXME: warn٤
	$data_to_send = "$msg\x0d\x0a";
    }
    elsif ($msg->isa($this->irc_message_class)) {
	# message_io_hook
	my $filtered = $this->_runloop->apply_filters(
	    [$msg], 'message_io_hook', $this, 'out');

	# message_encoding_hook
	$filtered = $this->_runloop->apply_filters(
	    $filtered, 'message_encoding_hook', $this, 'out', $encoding);

	foreach (@$filtered) {
	    $data_to_send .= $_->serialize("remark,$encoding")."\x0d\x0a";
	}

    }
    else {
	die "IrcIO::send_message : parameter msg was invalid; $msg\n";
    }

    if ($this->connected) {
	$this->append($data_to_send);
    }
    else {
	die "IrcIO::send_message : socket is not connected.\n";
    }
}

sub read {
    my ($this,$encoding) = @_;
    # Υ᥽åɤIRCåԤļꡢTiarra::IRC::MessageΥ󥹥󥹤򥭥塼ίޤ
    # åȤɤǡƤʤä硢Υ᥽åɤɤ褦ˤʤޤ
    # ֥åޤ줬ޤͽselectɤǧƤƲ
    # Υ᥽åɤ¹ԤȤǻϤƥåȤĤ줿ʬäϡ
    # ᥽åɼ¹Ը夫connected᥽åɤ֤褦ˤʤޤ

    $this->SUPER::read;

    while (1) {
	# CRLFޤLFԤνꡣ
	my $newline_pos = index($this->recvbuf,"\x0a");
	if ($newline_pos == -1) {
	    # ʬΥǡϤƤʤ
	    last;
	}

	my $current_line = substr($this->recvbuf,0,$newline_pos);
	$this->recvbuf(substr($this->recvbuf,$newline_pos+1));

	# CRLFä硢CRդƤΤǼ롣
	$current_line =~ s/\x0d$//;

	if (CORE::length($current_line) == 0) {
	    # Ԥϥå
	    next;
	}

	my $msg = $this->construct_irc_message(
	    Line => $current_line,
	    Encoding => $encoding);

	# message_encoding_hook
	my $filtered = $this->_runloop->apply_filters(
	    [$msg], 'message_encoding_hook', $this, 'in', $encoding);

	# message_io_hook
	$filtered = $this->_runloop->apply_filters(
	    $filtered, 'message_io_hook', $this, 'in');

	foreach (@$filtered) {
	    $_->purge_raw_params;
	    push @{$this->{recv_queue}}, $_;
	}
    }
}

sub pop_queue {
    # Υ᥽åɤϼ塼κǤŤΤФޤ
    # 塼ʤQueueIsEmptyExceptionꤲޤ
    my ($this) = @_;
    if (@{$this->{recv_queue}} == 0) {
	QueueIsEmptyException->new->throw;
    }
    else {
	return shift @{$this->{recv_queue}};
    }
}

1;
