# -----------------------------------------------------------------------------
# $Id: Reload.pm 607 2004-10-02 08:31:58Z topia $
# -----------------------------------------------------------------------------
package System::Reload;
use strict;
use warnings;
use base qw(Module);
use ReloadTrigger;
use Timer;
use Configuration;
use Mask;
use RunLoop;

sub new {
    my $class = shift;
    my $this = $class->SUPER::new(@_);

    if (!defined $this->config->conf_reloaded_notify ||
	    $this->config->conf_reloaded_notify) {
	$this->{conf_hook} = Configuration::Hook->new(
	    sub {
		my ($hook) = shift;
		RunLoop->shared_loop->notify_msg("Reloaded configuration file.");
	    })->install('reloaded');
    }
    return $this;
}

sub destruct {
    my $this = shift;

    $this->{conf_hook}->uninstall if defined $this->{conf_hook};
    $this->{conf_hook} = undef;
}

sub message_arrived {
    my ($this,$msg,$sender) = @_;
    my $do_reload = 0;

    # 饤Ȥȯ
    if ($sender->isa('IrcIO::Client')) {
	# ޥ̾ϰפƤ뤫
	if (Mask::match_deep([$this->config->broadcast_command('all')],
			     $msg->command)) {
	    RunLoop->shared_loop->broadcast_to_servers($msg->clone);
	    $do_reload = 1;
	} elsif (Mask::match_deep([$this->config->command('all')],
				  $msg->command)) {
	    $do_reload = 1;
	}
    }
    if ($do_reload) {
	# ɬפʤɤ¹ԡ
	ReloadTrigger->_install_reload_timer;
	return undef;
    }
    return $msg;
}

1;
=pod
info: confե⥸塼ιɤ륳ޥɤɲä롣
default: on

# ɤ¹Ԥ륳ޥ̾άȥޥɤɲäޤ
# 㤨"load"ꤹȡ"/load"ȯ褦Ȥ˥ɤ¹Ԥޤ
# λޥɤTiarra٤ΤǡIRCץȥ줿
# ޥ̾ꤹ٤ǤϤޤ
command: load

# command ƱǤФˤ֥ɥ㥹Ȥޤ
-broadcast-command: load-all

# confեɤȤΤޤ
# ⥸塼꤬ѹƤϡǤˤ餺
# ⥸塼뤴Ȥɽޤ1ޤϾά줿Τޤ
conf-reloaded-notify: 1
=cut
